mod interface;
mod bitboard;
mod movegen;
mod engine;
mod game;
mod evaluate;
mod search;
mod zobrist;
mod hash;

extern crate log;
extern crate simplelog;
extern crate rand;

use simplelog::*;

use std::sync::mpsc;
use std::{thread, fs::File};
use log::*;
use engine::Engine;

use evaluate::*;

fn main() {
    /*let mut builder = Builder::from_default_env();
    builder
        .filter(None, LevelFilter::Info)
        .target(Target::Pipe(Box::new(File::create("debug.log").unwrap())))
        //.target(Target::Stderr)
        .init();
        */
    
    //assert_eq!(std::mem::size_of::<crate::movegen::Move>(), 6);

    //let logfile = File::create("/home/nicolas/debug.log").unwrap();
    //simplelog::WriteLogger::init(LevelFilter::Info, Config::default(), logfile).unwrap();

    let (esend, erecv) = mpsc::channel();
    let (isend, irecv) = mpsc::channel();

    // spawn engine thread
    thread::spawn(move || {
        let mut engine = Engine::new(erecv, isend);
        engine.run();
    });

    interface::run(irecv, esend);
}


